package nl.iobyte.themeparkconnector.api.network.drivers;

import io.socket.client.Socket;
import nl.iobyte.themeparkconnector.ThemeParkConnector;
import nl.iobyte.themeparkconnector.api.network.io.SocketConnector;
import nl.iobyte.themeparkconnector.api.network.objects.SocketDriver;
import nl.iobyte.themeparkconnector.api.packet.objects.AbstractPacket;
import nl.iobyte.themeparkconnector.logger.ThemeParkConnectorLogger;

public class ClientDriver extends SocketDriver {

    /**
     * Register event to handle incoming packets
     * @param socket Socket
     * @param connector SocketConnector
     */
    public void boot(Socket socket, SocketConnector connector) {
        socket.on("data", args -> {
            try {
                AbstractPacket packet = ThemeParkConnector.getGson().fromJson(args[0].toString(), AbstractPacket.class);
                ThemeParkConnector.getInstance().getAPI().getNetworkingService().triggerPacket(packet);
            } catch (Exception e) {
                ThemeParkConnectorLogger.toConsole("Failed to parse incoming packet. The received data was: " + args[0].toString());
                e.printStackTrace();
            }
        });
    }

}
