package nl.iobyte.themeparkconnector.api.operator.adapter;

import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;
import nl.iobyte.themeparkconnector.api.operator.objects.panel.OperatorItem;
import java.lang.reflect.Type;

public class OperatorItemAdapter implements JsonSerializer<OperatorItem> {

    /**
     * Serializes OperatorItem to json
     * @param src OperatorItem
     * @param typeOfSrc Type
     * @param context JsonSerializationContext
     * @return JsonElement
     */
    @Override
    public JsonElement serialize(OperatorItem src, Type typeOfSrc, JsonSerializationContext context) {
        JsonObject result = new JsonObject();
        result.add("id", context.serialize(src.getID()));
        result.add("name", context.serialize(src.getName()));
        result.add("state", context.serialize(src.getActiveState()));

        return result;
    }

}
