package nl.iobyte.themeparkconnector.listeners;

import nl.iobyte.themepark.api.event.attraction.AttractionStatusChangeEvent;
import nl.iobyte.themeparkconnector.ThemeParkConnector;
import nl.iobyte.themeparkconnector.api.client.ClientConnection;
import nl.iobyte.themeparkconnector.api.network.packet.operator.StatusChangePacket;
import nl.iobyte.themeparkconnector.api.operator.objects.AttractionOperator;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;

public class AttractionListener implements Listener {

    @EventHandler
    public void onChange(AttractionStatusChangeEvent e) {
        AttractionOperator operator = ThemeParkConnector.getInstance().getAPI().getOperatorService().getOperator(e.getAttraction().getID());
        if(operator == null)
            return;

        ClientConnection client = operator.getClientConnection();
        if(client == null)
            return;

        //Packet
        ThemeParkConnector.getInstance().getAPI().getNetworkingService().send(
                client,
                new StatusChangePacket(
                        e.getCurrent()
                )
        );
    }

}
